-- load image files
	imgBack = image.load("background.png");
	imgSmile = image.load("smile.png");
	imgCross = image.load("cross.png");
	imgButton = image.load("button.png");
	imgTitle = image.load("title.png");
	imgTButton = image.load("titlebutton.png");
	
-- set up global variables
	touch_x = 0;
	touch_y = 0;
	smilenum = 0;
	maxsmilenum = 1;
	time = 20;
	score = 0;
	misses = 0;
	field = {};
	playing = false;
	endgame = false;
	mode = 1;
	menu = 1;
	cWhite = color.new(0,0,0);
	text.color = cWhite;
	
-- get the previous highscores
-- replace this with i/o functions..
    highscore = 20;

-- set up the values for field
	for i = 1, 20 do
		field[i] = 0;
	end;
    	
-- Draw the Background
	function clearScreen()
		if playing == true then
			imgBack:draw(0,0);
		else
		    imgTitle:draw(0,0);
		end;
	end;
	
-- Draw the values of touch_x and touch_y
	function drawPos()
		local old = text.size(14);
		local itext = tostring(score);
		local ktext = tostring(misses);
		text.draw(291,22,"Score","center");
		text.draw(291,40,itext,"center");
		text.draw(291,62,"Misses","center");
		text.draw(291,80,ktext,"center");
		text.draw(291,102,"Highscore","center");
		text.draw(291,120,tostring(highscore),"center");
		text.size(old);
	end;
	
-- Checks if the touch is within a region
	function touchRegion(rx, ry, w, h)

		if touch_x >= rx and touch_x <= (rx + w) and touch_y >= ry and touch_y <= (ry + h) then
			return true;
		else
			return false;
		end;

	end;
	
-- Change a random value of field to 2 if it is = to 0
	function addSmile()
		local ivalue = math.random(1,20);
		if field[ivalue] == 0 then
			field[ivalue] = 2;
			smilenum = smilenum + 1;
		end;
	end;
	
-- Draw a smile in the correct place
   function drawSmile()
   
   		for i = 0,19 do
   		    local line = math.floor(i/5);
   		    local x = ((i-(line*5))*56)+9+4;
   		    local y = (line*56)+8+4;
   			if field[i+1] >= 2 then
			    imgSmile:draw(x,y);
			    field[i+1] = field[i+1] + 1;
			    if field[i+1] == time then
					field[i+1] = 0;
					smilenum = smilenum - 1;
					misses = misses + 1;
				end;
			end;
			if field[i+1] < 0 then
			    imgCross:draw(x,y);
			    field[i+1] = field[i+1] + 1;
			end;
		end;
   end;
   
-- Calculate the pressed region
	function pressSmile()
		--find the pressed region
		if touchRegion(9,8,289,232) then
			local fx = math.floor((touch_x-9)/56)+1;
			local fy = math.floor((touch_y-8)/56)+1;
		    local f = (fy-1)*5+fx;
		    
		    if field[f] >= 2 then
		    	field[f] = -8;
		    	smilenum = smilenum - 1;
		    	score = score + 1;
		    end;
		    
		    --text.draw(0,0,tostring(f));
		    
		end;
	end;
	
-- Increasing difficulty
	function incDif()
		maxsmilenum = math.floor(score/(20*maxsmilenum))+1;
	end;
	
-- Lose
	function lose()
	    if misses == 10 then
			playing = false;
			menu = 1;
      		touch_x = 0;
      		touch_y = 0;
      		os.sleep(8);			
		end;
	end;
	
-- Buttons
	function buttons()
		--IN PLAY
		--quit button
		if playing == true then
			imgButton:draw(303,200);
			text.draw(307,204,"Quit");
			if touchRegion(303,200,85,27) == true then
      			endgame = true;
			end;
			--reset button
			imgButton:draw(303,170);
		    text.draw(307,174,"Reset");
		    if touchRegion(303,174,85,27) == true then
      			misses = 10;
      			menu = 1;
			end;
		end;
		--MAIN MENU 1
		--Play button
		if playing == false then
			if menu == 1 then
			    menuOne();
			    local old = text.size(12);
			    text.draw(0,240-12,"V1.8 - by bzdbbb");
			    text.size(old);
			elseif menu == 2 then
				menuTwo();
			end;
		end;
	end;
	
-- Start Game
	function startGame()
		playing = true;
		clearScreen();
      	smilenum = 0;
		maxsmilenum = 1;
		score = 0;
		misses = 0;
				
		-- set up the values for field
		for i = 1, 20 do
			field[i] = 0;
		end;
      	clearScreen();
      	buttons();
      	os.sleep(20);
    end;
    
-- MENU 1 BUTTONS
	function menuOne()
		clearScreen();
		local old = text.size(24);
		imgTButton:draw(114,102);
		text.draw(0,106,"New Game","center");
		if touchRegion(114,102,171,37) == true then
      		menu = 2;
      		touch_x = 0;
      		touch_y = 0;
      		os.sleep(8);
		end;
		--Highscores
		imgTButton:draw(114,144);
		text.draw(0,148,"Highscores","center");
		--Quit Button
		imgTButton:draw(114,186);
		text.draw(0,190,"Quit","center");
		if touchRegion(114,186,85,27) == true then
      		endgame = true;
		end;
		text.size(old);
    end;
    

-- MENU 2 BUTTONS
	function menuTwo()
		clearScreen();
		local old = text.size(24);
		-- Game Mode: Easy
		imgTButton:draw(114,102);
		text.draw(0,106,"Easy","center");
		if touch_x >= 114 and touch_x <= (114 + 171) and touch_y >= 102 and touch_y <= (102 + 37) then
			time = 30;
			startGame();
		end;
		--Game Mode: Medium
		imgTButton:draw(114,144);
		text.draw(0,148,"Medium","center");
		if touch_x >= 114 and touch_x <= (114 + 171) and touch_y >= 144 and touch_y <= (144 + 37) then
			time = 20;
      		startGame();
		end;
		--Game Mode: Hard
		imgTButton:draw(114,186);
		text.draw(0,190,"Hard","center");
		if touch_x >= 114 and touch_x <= (114 + 171) and touch_y >= 186 and touch_y <= (102 + 186) then
			time = 10;
	   		startGame();
		end;
		text.size(old);
	end;

-- Program Loop	
	while true do
	
		-- Set the screen to blank
		clearScreen();
        buttons();
        
        if playing == true then
			if(smilenum < maxsmilenum) then addSmile(); end;
			drawSmile();
			incDif();
			drawPos();
			lose();
		end;
		
		--If a control has been red
		if control.read() == 1 then
	
			--If the touch has changed then update values
			if (control.isTouch() == 1) and (touch.click() == 1) then
				touch_x, touch_y = touch.pos();
				if playing == true then pressSmile(); end;
			end;
	
			--If home has been pressed then exit
			if (control.isButton() == 1) and (button.home() == 1) and (button.click() == 1) then 
				break;
			end;
			
		end;
		
		screen.update();
	
		os.sleep(8);
		
		if endgame == true then break; end;
	
	end;

	
	
	